# Models

## The CreateFieldBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"CreateFieldBody":{"type":"object","properties":{"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string","minLength":1,"maxLength":100}},"name":{"description":"Field name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},"refTableName":{"description":"Reference table name (for reference/reverse types)","oneOf":[{"type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},{}],"default":null},"type":{"description":"Field type","type":"string","enum":["string","number","boolean","choice","multi","file","date","timestamp","time","timeinterval","appointment","icon","color","user","reference","reverse"]},"variant":{"description":"Field variant (for string type)","type":"string","enum":["multiline-text","text","phone","email","url","location"]},"index":{"description":"Field is indexed","type":"boolean"},"readRoles":{"description":"Roles allowed to read the field","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","user"]}},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"unique":{"description":"Field is unique","type":"boolean"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","user"]}}},"required":["labels","name","type"]}}}}
```

## The FieldResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"FieldResponse":{"type":"object","properties":{"data":{"description":"Field details","type":"object","properties":{"index":{"description":"Field is indexed","type":"boolean"},"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"description":"Field name","type":"string"},"readRoles":{"description":"Roles allowed to read the field","type":"array","items":{"type":"string"}},"refTableId":{"description":"Reference table id","type":"string"},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"type":{"description":"Field type","type":"string","enum":["any","appointment","boolean","choice","color","date","file","function","html","icon","lambda","multi","number","react","reference","reverse","rowId","string","styled","time","timeinterval","timestamp","unknown","user","void"]},"unique":{"description":"Field is unique","type":"boolean"},"variant":{"description":"Field variant (for string type)","type":"string"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","items":{"type":"string"}}},"required":["name","type"]}},"required":["data"]}}}}
```

## The ErrorResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"ErrorResponse":{"type":"object","properties":{"error":{"type":"object","properties":{"message":{"description":"Error message","type":"string"}},"required":["message"]}},"required":["error"]}}}}
```

## The CreateFieldsBatchBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"CreateFieldsBatchBody":{"type":"array","minItems":1,"items":{"type":"object","properties":{"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string","minLength":1,"maxLength":100}},"name":{"description":"Field name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},"refTableName":{"description":"Reference table name (for reference/reverse types)","oneOf":[{"type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},{}],"default":null},"type":{"description":"Field type","type":"string","enum":["string","number","boolean","choice","multi","file","date","timestamp","time","timeinterval","appointment","icon","color","user","reference","reverse"]},"variant":{"description":"Field variant (for string type)","type":"string","enum":["multiline-text","text","phone","email","url","location"]},"index":{"description":"Field is indexed","type":"boolean"},"readRoles":{"description":"Roles allowed to read the field","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","user"]}},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"unique":{"description":"Field is unique","type":"boolean"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","user"]}}},"required":["labels","name","type"]}}}}}
```

## The FieldsResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"FieldsResponse":{"type":"object","properties":{"data":{"description":"List of fields","type":"array","items":{"type":"object","properties":{"index":{"description":"Field is indexed","type":"boolean"},"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"description":"Field name","type":"string"},"readRoles":{"description":"Roles allowed to read the field","type":"array","items":{"type":"string"}},"refTableId":{"description":"Reference table id","type":"string"},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"type":{"description":"Field type","type":"string","enum":["any","appointment","boolean","choice","color","date","file","function","html","icon","lambda","multi","number","react","reference","reverse","rowId","string","styled","time","timeinterval","timestamp","unknown","user","void"]},"unique":{"description":"Field is unique","type":"boolean"},"variant":{"description":"Field variant (for string type)","type":"string"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","items":{"type":"string"}}},"required":["name","type"]}}},"required":["data"]}}}}
```

## The DeleteFieldsBatchBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"DeleteFieldsBatchBody":{"type":"object","properties":{"fieldNames":{"type":"array","minItems":1,"items":{"description":"Field name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"}}},"required":["fieldNames"]}}}}
```

## The UpdateFieldBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"UpdateFieldBody":{"type":"object","properties":{"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string","minLength":1,"maxLength":100}},"name":{"description":"Field name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},"index":{"description":"Field is indexed","type":"boolean"},"readRoles":{"description":"Roles allowed to read the field","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","user"]}},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"unique":{"description":"Field is unique","type":"boolean"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","user"]}}}}}}}
```

## The CreateModuleBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"CreateModuleBody":{"description":"Create Module request body","type":"object","properties":{"name":{"description":"Module name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},"hideNavigation":{"description":"Hide module from navigation","type":"boolean"},"icon":{"description":"Module icon","type":"object","properties":{"color":{"type":"string"},"filling":{"oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"type":"string","minLength":1}},"required":["icon"]},"isHidden":{"description":"Hide module","type":"boolean"},"labels":{"description":"Module labels (localized)","type":"object","additionalProperties":{"type":"string","minLength":1,"maxLength":100}},"openRoles":{"description":"Module open roles","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}}},"required":["name"]}}}}
```

## The ModuleResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"ModuleResponse":{"type":"object","properties":{"data":{"description":"Module details","type":"object","properties":{"hideNavigation":{"description":"Hide module from navigation","type":"boolean"},"icon":{"description":"Module icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isHidden":{"description":"Hide module","type":"boolean"},"labels":{"description":"Module labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"openRoles":{"description":"Module open roles","type":"array","items":{"type":"string"}},"tables":{"type":"array","items":{"type":"object","properties":{"createRoles":{"description":"Roles allowed to create records","type":"array","items":{"type":"string"}},"deleteRoles":{"description":"Roles allowed to delete records","type":"array","items":{"type":"string"}},"fields":{"type":"array","items":{"type":"object","properties":{"index":{"description":"Field is indexed","type":"boolean"},"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"description":"Field name","type":"string"},"readRoles":{"description":"Roles allowed to read the field","type":"array","items":{"type":"string"}},"refTableId":{"description":"Reference table id","type":"string"},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"type":{"description":"Field type","type":"string","enum":["any","appointment","boolean","choice","color","date","file","function","html","icon","lambda","multi","number","react","reference","reverse","rowId","string","styled","time","timeinterval","timestamp","unknown","user","void"]},"unique":{"description":"Field is unique","type":"boolean"},"variant":{"description":"Field variant (for string type)","type":"string"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","items":{"type":"string"}}},"required":["name","type"]}},"hasFiles":{"description":"Enable files for the table","type":"boolean"},"hasGlobalSearch":{"description":"Enable global search for the table","type":"boolean"},"hasHistory":{"description":"Enable history for the table","type":"boolean"},"icon":{"description":"Table icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isEmailLinkingEnabled":{"description":"Enable email linking for the table","type":"boolean"},"isHidden":{"description":"Hide the table","type":"boolean"},"labels":{"description":"Table labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"readRoles":{"description":"Roles allowed to read records","type":"array","items":{"type":"string"}},"writeRoles":{"description":"Roles allowed to update records","type":"array","items":{"type":"string"}}},"required":["name"]}}},"required":["name"]}},"required":["data"]}}}}
```

## The DeleteModuleResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"DeleteModuleResponse":{"type":"object","properties":{"data":{"type":"object","properties":{"id":{"description":"Deleted module id","type":"string"}},"required":["id"]}},"required":["data"]}}}}
```

## The ModulesResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"ModulesResponse":{"type":"object","properties":{"data":{"description":"List of modules","type":"array","items":{"type":"object","properties":{"hideNavigation":{"description":"Hide module from navigation","type":"boolean"},"icon":{"description":"Module icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isHidden":{"description":"Hide module","type":"boolean"},"labels":{"description":"Module labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"openRoles":{"description":"Module open roles","type":"array","items":{"type":"string"}},"tables":{"type":"array","items":{"type":"object","properties":{"createRoles":{"description":"Roles allowed to create records","type":"array","items":{"type":"string"}},"deleteRoles":{"description":"Roles allowed to delete records","type":"array","items":{"type":"string"}},"fields":{"type":"array","items":{"type":"object","properties":{"index":{"description":"Field is indexed","type":"boolean"},"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"description":"Field name","type":"string"},"readRoles":{"description":"Roles allowed to read the field","type":"array","items":{"type":"string"}},"refTableId":{"description":"Reference table id","type":"string"},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"type":{"description":"Field type","type":"string","enum":["any","appointment","boolean","choice","color","date","file","function","html","icon","lambda","multi","number","react","reference","reverse","rowId","string","styled","time","timeinterval","timestamp","unknown","user","void"]},"unique":{"description":"Field is unique","type":"boolean"},"variant":{"description":"Field variant (for string type)","type":"string"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","items":{"type":"string"}}},"required":["name","type"]}},"hasFiles":{"description":"Enable files for the table","type":"boolean"},"hasGlobalSearch":{"description":"Enable global search for the table","type":"boolean"},"hasHistory":{"description":"Enable history for the table","type":"boolean"},"icon":{"description":"Table icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isEmailLinkingEnabled":{"description":"Enable email linking for the table","type":"boolean"},"isHidden":{"description":"Hide the table","type":"boolean"},"labels":{"description":"Table labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"readRoles":{"description":"Roles allowed to read records","type":"array","items":{"type":"string"}},"writeRoles":{"description":"Roles allowed to update records","type":"array","items":{"type":"string"}}},"required":["name"]}}},"required":["name"]}}},"required":["data"]}}}}
```

## The UpdateModuleBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"UpdateModuleBody":{"description":"Update Module request body","type":"object","properties":{"name":{"description":"Module name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},"hideNavigation":{"description":"Hide module from navigation","type":"boolean"},"icon":{"description":"Module icon","type":"object","properties":{"color":{"type":"string"},"filling":{"oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"type":"string","minLength":1}},"required":["icon"]},"isHidden":{"description":"Hide module","type":"boolean"},"labels":{"description":"Module labels (localized)","type":"object","additionalProperties":{"type":"string","minLength":1,"maxLength":100}},"openRoles":{"description":"Module open roles","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}}}}}}}
```

## The AddRowsBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"AddRowsBody":{"type":"object","properties":{"records":{"description":"Array of records to add to the target table","type":"array","minItems":1,"items":{"type":"object","additionalProperties":{}}}},"required":["records"]}}}}
```

## The CreateRowsResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"CreateRowsResponse":{"type":"object","properties":{"data":{"type":"object","properties":{"ids":{"description":"Created row ids","type":"array","items":{"type":"string"}}},"required":["ids"]}},"required":["data"]}}}}
```

## The DeleteRowsBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"DeleteRowsBody":{"type":"object","properties":{"records":{"description":"Array of record ids to delete","type":"array","minItems":1,"items":{"type":"integer","minimum":-9007199254740991,"exclusiveMinimum":false,"maximum":9007199254740991,"exclusiveMaximum":false}}},"required":["records"]}}}}
```

## The DeleteRowsResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"DeleteRowsResponse":{"type":"object","properties":{"data":{"type":"object","properties":{"deletedIds":{"description":"Deleted row ids","type":"array","items":{"type":"string"}}},"required":["deletedIds"]}},"required":["data"]}}}}
```

## The RowsResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"RowsResponse":{"type":"object","properties":{"data":{"description":"List of rows","type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"values":{"type":"object","additionalProperties":{"oneOf":[{"type":"boolean"},{},{"type":"number"},{"type":"string"}]}}},"required":["id","values"]}},"meta":{"type":"object","properties":{"filter":{"description":"Applied filter conditions","type":"object","additionalProperties":{"oneOf":[{"type":"boolean"},{},{"type":"number"},{"type":"string"}]}},"sort":{"description":"Applied sort field","type":"string"}},"required":["filter","sort"]},"page_info":{"description":"Pagination information","type":"object","properties":{"has_more":{"description":"Whether more rows are available","type":"boolean"},"limit":{"description":"Maximum rows per page","type":"number"},"offset":{"description":"Current offset","type":"number"}},"required":["has_more","limit","offset"]}},"required":["data","page_info"]}}}}
```

## The ImportCSVResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"ImportCSVResponse":{"type":"object","properties":{"data":{"type":"object","properties":{"rowsImported":{"description":"Number of rows successfully imported","type":"number"},"rowsSkipped":{"description":"Number of rows skipped (for update mode when no match is found)","type":"number"},"rowsUpdated":{"description":"Number of existing rows updated","type":"number"}},"required":["rowsImported","rowsSkipped","rowsUpdated"]}},"required":["data"]}}}}
```

## The UpdateRowsBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"UpdateRowsBody":{"type":"object","properties":{"records":{"description":"Array of records to update (each must include an id field as a positive integer)","type":"array","minItems":1,"items":{"type":"object","properties":{"id":{"type":"integer","minimum":-9007199254740991,"exclusiveMinimum":false,"maximum":9007199254740991,"exclusiveMaximum":false}},"required":["id"]}}},"required":["records"]}}}}
```

## The UpdateRowsResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"UpdateRowsResponse":{"type":"object","properties":{"data":{"type":"object","properties":{"updatedIds":{"description":"Updated row ids","type":"array","items":{"type":"string"}}},"required":["updatedIds"]}},"required":["data"]}}}}
```

## The CreateTableBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"CreateTableBody":{"type":"object","properties":{"icon":{"description":"Table icon","type":"object","properties":{"color":{"type":"string"},"filling":{"oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"type":"string","minLength":1}},"required":["icon"]},"labels":{"description":"Table labels (localized)","type":"object","additionalProperties":{"type":"string","minLength":1,"maxLength":100}},"name":{"description":"Table name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},"createRoles":{"description":"Roles allowed to create records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}},"deleteRoles":{"description":"Roles allowed to delete records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}},"hasFiles":{"description":"Enable files for the table","type":"boolean"},"hasGlobalSearch":{"description":"Enable global search for the table","type":"boolean"},"hasHistory":{"description":"Enable history for the table","type":"boolean"},"isEmailLinkingEnabled":{"description":"Enable email linking for the table","type":"boolean"},"isHidden":{"description":"Hide the table","type":"boolean"},"readRoles":{"description":"Roles allowed to read records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}},"writeRoles":{"description":"Roles allowed to update records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}}},"required":["labels","name"]}}}}
```

## The TableResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"TableResponse":{"type":"object","properties":{"data":{"description":"Table details","type":"object","properties":{"createRoles":{"description":"Roles allowed to create records","type":"array","items":{"type":"string"}},"deleteRoles":{"description":"Roles allowed to delete records","type":"array","items":{"type":"string"}},"fields":{"type":"array","items":{"type":"object","properties":{"index":{"description":"Field is indexed","type":"boolean"},"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"description":"Field name","type":"string"},"readRoles":{"description":"Roles allowed to read the field","type":"array","items":{"type":"string"}},"refTableId":{"description":"Reference table id","type":"string"},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"type":{"description":"Field type","type":"string","enum":["any","appointment","boolean","choice","color","date","file","function","html","icon","lambda","multi","number","react","reference","reverse","rowId","string","styled","time","timeinterval","timestamp","unknown","user","void"]},"unique":{"description":"Field is unique","type":"boolean"},"variant":{"description":"Field variant (for string type)","type":"string"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","items":{"type":"string"}}},"required":["name","type"]}},"hasFiles":{"description":"Enable files for the table","type":"boolean"},"hasGlobalSearch":{"description":"Enable global search for the table","type":"boolean"},"hasHistory":{"description":"Enable history for the table","type":"boolean"},"icon":{"description":"Table icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isEmailLinkingEnabled":{"description":"Enable email linking for the table","type":"boolean"},"isHidden":{"description":"Hide the table","type":"boolean"},"labels":{"description":"Table labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"readRoles":{"description":"Roles allowed to read records","type":"array","items":{"type":"string"}},"writeRoles":{"description":"Roles allowed to update records","type":"array","items":{"type":"string"}}},"required":["name"]}},"required":["data"]}}}}
```

## The DeleteTableResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"DeleteTableResponse":{"type":"object","properties":{"data":{"type":"object","properties":{"id":{"description":"Deleted table id","type":"string"}},"required":["id"]}},"required":["data"]}}}}
```

## The TablesResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"TablesResponse":{"type":"object","properties":{"data":{"description":"List of tables","type":"array","items":{"type":"object","properties":{"createRoles":{"description":"Roles allowed to create records","type":"array","items":{"type":"string"}},"deleteRoles":{"description":"Roles allowed to delete records","type":"array","items":{"type":"string"}},"fields":{"type":"array","items":{"type":"object","properties":{"index":{"description":"Field is indexed","type":"boolean"},"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"description":"Field name","type":"string"},"readRoles":{"description":"Roles allowed to read the field","type":"array","items":{"type":"string"}},"refTableId":{"description":"Reference table id","type":"string"},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"type":{"description":"Field type","type":"string","enum":["any","appointment","boolean","choice","color","date","file","function","html","icon","lambda","multi","number","react","reference","reverse","rowId","string","styled","time","timeinterval","timestamp","unknown","user","void"]},"unique":{"description":"Field is unique","type":"boolean"},"variant":{"description":"Field variant (for string type)","type":"string"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","items":{"type":"string"}}},"required":["name","type"]}},"hasFiles":{"description":"Enable files for the table","type":"boolean"},"hasGlobalSearch":{"description":"Enable global search for the table","type":"boolean"},"hasHistory":{"description":"Enable history for the table","type":"boolean"},"icon":{"description":"Table icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isEmailLinkingEnabled":{"description":"Enable email linking for the table","type":"boolean"},"isHidden":{"description":"Hide the table","type":"boolean"},"labels":{"description":"Table labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"readRoles":{"description":"Roles allowed to read records","type":"array","items":{"type":"string"}},"writeRoles":{"description":"Roles allowed to update records","type":"array","items":{"type":"string"}}},"required":["name"]}}},"required":["data"]}}}}
```

## The UpdateTableBody object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"UpdateTableBody":{"type":"object","properties":{"icon":{"description":"Table icon","type":"object","properties":{"color":{"type":"string"},"filling":{"oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"type":"string","minLength":1}},"required":["icon"]},"labels":{"description":"Table labels (localized)","type":"object","additionalProperties":{"type":"string","minLength":1,"maxLength":100}},"name":{"description":"Table name","type":"string","minLength":1,"maxLength":100,"pattern":"^[a-z0-9_]+$"},"createRoles":{"description":"Roles allowed to create records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}},"deleteRoles":{"description":"Roles allowed to delete records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}},"hasFiles":{"description":"Enable files for the table","type":"boolean"},"hasGlobalSearch":{"description":"Enable global search for the table","type":"boolean"},"hasHistory":{"description":"Enable history for the table","type":"boolean"},"isEmailLinkingEnabled":{"description":"Enable email linking for the table","type":"boolean"},"isHidden":{"description":"Hide the table","type":"boolean"},"readRoles":{"description":"Roles allowed to read records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}},"writeRoles":{"description":"Roles allowed to update records","type":"array","minItems":1,"maxItems":2,"items":{"type":"string","enum":["admin","editor"]}}}}}}}
```

## The WorkspaceResponse object

```json
{"openapi":"3.0.0","info":{"title":"Ninox Public API","version":"1.0.0"},"components":{"schemas":{"WorkspaceResponse":{"type":"object","properties":{"data":{"description":"Workspace details","type":"object","properties":{"modules":{"type":"array","items":{"type":"object","properties":{"hideNavigation":{"description":"Hide module from navigation","type":"boolean"},"icon":{"description":"Module icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isHidden":{"description":"Hide module","type":"boolean"},"labels":{"description":"Module labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"openRoles":{"description":"Module open roles","type":"array","items":{"type":"string"}},"tables":{"type":"array","items":{"type":"object","properties":{"createRoles":{"description":"Roles allowed to create records","type":"array","items":{"type":"string"}},"deleteRoles":{"description":"Roles allowed to delete records","type":"array","items":{"type":"string"}},"fields":{"type":"array","items":{"type":"object","properties":{"index":{"description":"Field is indexed","type":"boolean"},"labels":{"description":"Field labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"description":"Field name","type":"string"},"readRoles":{"description":"Roles allowed to read the field","type":"array","items":{"type":"string"}},"refTableId":{"description":"Reference table id","type":"string"},"required":{"description":"Field is required","type":"boolean"},"search":{"description":"Field is searchable","type":"boolean"},"type":{"description":"Field type","type":"string","enum":["any","appointment","boolean","choice","color","date","file","function","html","icon","lambda","multi","number","react","reference","reverse","rowId","string","styled","time","timeinterval","timestamp","unknown","user","void"]},"unique":{"description":"Field is unique","type":"boolean"},"variant":{"description":"Field variant (for string type)","type":"string"},"writeRoles":{"description":"Roles allowed to write to the field","type":"array","items":{"type":"string"}}},"required":["name","type"]}},"hasFiles":{"description":"Enable files for the table","type":"boolean"},"hasGlobalSearch":{"description":"Enable global search for the table","type":"boolean"},"hasHistory":{"description":"Enable history for the table","type":"boolean"},"icon":{"description":"Table icon","type":"object","properties":{"color":{"description":"Icon color (hex string)","type":"string"},"filling":{"description":"Icon filling","oneOf":[{"type":"number","minimum":0,"maximum":0},{"type":"number","minimum":1,"maximum":1}]},"icon":{"description":"Icon name","type":"string"}},"required":["icon"]},"isEmailLinkingEnabled":{"description":"Enable email linking for the table","type":"boolean"},"isHidden":{"description":"Hide the table","type":"boolean"},"labels":{"description":"Table labels (localized)","type":"object","additionalProperties":{"type":"string"}},"name":{"type":"string"},"readRoles":{"description":"Roles allowed to read records","type":"array","items":{"type":"string"}},"writeRoles":{"description":"Roles allowed to update records","type":"array","items":{"type":"string"}}},"required":["name"]}}},"required":["name"]}},"name":{"type":"string"}},"required":["name"]}},"required":["data"]}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ninox.com/ninox-api/de/api-reference/api-endpoints/models.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
